require 'optparse'

Version = '1.0.0'

opt = OptionParser.new
opt.on('-n', '--line-number',
       '行番号を表示します')
opt.on('-H', '--with-filename',
       'ファイル名を表示します')
params = {}
args = opt.parse(ARGV, into: params)
if args.size != 2
  $stderr.puts "引数の数が合いません"
  $stderr.puts opt.help 
  exit 1
end

pattern, filename = args
pattern = Regexp.new(pattern)
content = File.read(filename)
content.each_line.with_index(1) do |line, lineno|
  next unless line =~ pattern
  out = ""
  out << "#{filename}:" if params[:"with-filename"]
  out << "#{lineno}:" if params[:"line-number"]
  out << " " unless out.empty?
  out << line
  puts out
end
