require 'thor'

class CLI < Thor
  option :with_filename, aliases: :H
  option :line_number, aliases: :n
  desc "grep", "Find lines with a Regexp"
  def grep(pattern, filename)
    pattern = Regexp.new(pattern)
    content = File.read(filename)
    content.each_line.with_index(1) do |line, lineno|
      next unless line =~ pattern
      out = ""
      out << "#{filename}:" if options[:with_filename]
      out << "#{lineno}:" if options[:line_number]
      out << " " unless out.empty?
      out << line
      puts out
    end
  end
end

CLI.start(ARGV)
